using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;
using CSRedis;
using Microsoft.VisualBasic;

namespace Common
{
    /// <summary>
    /// Redis缓存辅助类
    /// </summary>
    public class CSRedisCacheHelper
    {
        public static CSRedisClient redis;
        private static int SessionExpireMinutes = 30;
        static CSRedisCacheHelper()
        {
            var redisHostStr = "127.0.0.1:6379";
            if (!string.IsNullOrEmpty(redisHostStr))
            {
                redis = new CSRedisClient(redisHostStr + ",password=,defaultDatabase=1");
            }
        }

        public static void Sub()
        {
            redis.Subscribe(("mypub", MsgBoxResult=>
            {
                Console.WriteLine("shou dao: "+MsgBoxResult.Body);
            }));
        }
        /// <summary>
        /// 添加缓存
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="key"></param>
        /// <param name="value"></param>
        public static void Set<T>(string key, T value)
        {
            redis.Set(key, value, SessionExpireMinutes * 60);
        }

        public static T Get<T>(string key)
        {
            return redis.Get<T>(key);
        }

        public static void Forever<T>(string key, T value)
        {
            redis.Set(key, value, -1);
        }
        public static void Del(string key)
        {
            redis.Del(key);
        }

        /// <summary>
        /// 判断是否存在
        /// </summary>
        /// <param name="key"></param>
        /// <param name="mac"></param>
        /// <returns></returns>
        public static bool Contains(string key, string mac)
        {
            bool result = redis.Exists(mac);
            if (!result)
            {
                result = redis.Exists(key);
            }
            return result;
        }

        public static bool Contains(string key)
        {
            bool result = redis.Exists(key);
            return result;
        }
        /// <summary>
        /// 添加Hash缓存
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="key"></param>
        /// <param name="value"></param>
        public static void HMSet<T>(string key, T value)
        {
            redis.HMSet(key, value);
        }
        /// <summary>
        /// 获取Hash缓存
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="key"></param>
        /// <returns></returns>
        public static T[] HMGet<T>(string key)
        {
            return redis.HMGet<T>(key);
        }
        /// <summary>
        /// 删除Hash缓存
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="key"></param>
        /// <returns></returns>
        public static long HDel<T>(string key)
        {
            return redis.HDel(key);
        }
    }
}
